import { Box } from "@mui/material"
import { useEffect, useState } from "react"


function CalendarWeekTask({ height, width, left, top, task, zIndex, handleOpen, setCurrentTask, modal}) {
  const [zIndexStyle, setZIndexStyle] = useState(10)
  const [color, setColor] = useState('')
  useEffect(() => {
    if (task.priority) {
      if (task.priority === 'A') setColor('rgb(32, 138, 250)')
      if (task.priority === 'B') setColor('lightgreen')
      if (task.priority === 'C') setColor('yellow')
    } else {
      setColor('rgb(171, 157, 157);')
    }
    setZIndexStyle(zIndex)
  }, [task])

  useEffect(() => {
    if (!modal) {
      setZIndexStyle(zIndex)
    }
  }, [modal])

  const onClickTaskHandler = (e, task) => {
    e.stopPropagation();
    setCurrentTask((prevState) => {
      return {
        ...task,
        infoForCell: {
          ...task.infoForCell,
          endHour: task.infoForCell.endHour + 1
        }
      }
    });
    setZIndexStyle(100)
    handleOpen(e)
  }

  const styles = {
    boxSizing: 'border-box',
    borderRadius: '3px',
    border: '1px solid white',
    backgroundColor: color,
    height: `${height - 1}px`,
    width: `${width - 1}px`,
    position: 'absolute',
    left: left,
    top: top,
    zIndex: zIndexStyle,
    textAlign: 'left',
    overflow: 'hidden',
    textOverflow: 'ellipsis',
    '&:hover': {
      cursor: 'pointer',
      boxShadow: 'inset 0 0 100px 100px rgba(255, 255, 255, 0.3)'
    },
  }

  return (
    <Box
      onClick={(e)=>{onClickTaskHandler(e, task)}}
      sx={styles}>
        <span style={{textOverflow: 'ellipsis', padding: '5px 0 0 5px'}}>
          {task.title} 
        </span>
    </Box>);
}

export default CalendarWeekTask;